function CU=myCU(data,label)
% not averaged across clusters by 1/k
[rows, m]=size(data);
CU=0;
uniqueLabel=unique(label);
k=length(uniqueLabel);
for j=1:m
    attributes=data(:,j);
    values=unique(attributes);
    nInCluster=length(values);
    if nInCluster>1
        for q=1:nInCluster 
            p1=length(find(attributes==values(q)))/rows;
            for i=1:k
                attributesInCluster=attributes(label==uniqueLabel(i));                
                p2=length(find(attributesInCluster==values(q)))/length(attributesInCluster);
                CU=CU+(p2^2-p1^2)*length(attributesInCluster)/rows;
            end
        end
    end
end
% CU=CU/k;
end
