function [ resultLabel] = myKmodes( k,dataSet)
%KMODES Summary of this function goes here
%   Detailed explanation goes here 
%   ----Inputs ----
%   k: partition size 
%   dataSet: data, the last column is the true label  ݾһΪǩ
%   ----Outputs ----
%   resultLabel: clustering label ǩ


dataS=dataSet(:,1:(size(dataSet,2)-1));
[row column]=size(dataS);
%ÿεĿ꺯
objValueVector=[];
%ѭ
iteratorNum=0;


resultLabel=zeros(row,1);
while(k~=length(unique(resultLabel)))
%ѡȡk
r=randperm(row);
ran=r(1:k);
t1=clock;
IC=ran;
%еһλ
for i=1:row
    data1=dataS(i,:);
    selectCluster=zeros(1,k);
    for j=1:k
        data2=dataS(IC(j),:);
        selectCluster(1,j)=calculateDis(data1,data2);
    end
    [minx tlabel]=min(selectCluster);
    resultLabel(i,1)=tlabel;
end

%ĵ㣬һλ,ֱĿ꺯
while(true)
    iteratorNum=iteratorNum+1;
    newcenter=updataCenters(k,resultLabel,dataS);
    for i=1:row
        data1=dataS(i,:);
        selectCluster=zeros(1,k);
        for j=1:k
            data2=newcenter(j,:);
            selectCluster(1,j)=calculateDis(data1,data2);
        end
        [minx tlabel]=min(selectCluster);
        resultLabel(i,1)=tlabel;
    end
    objValue=calculateObjectFunction(k,resultLabel,dataS,newcenter);
    
    if((size(objValueVector,2)>0)&&(objValue==objValueVector(1,size(objValueVector,2)))) || length(unique(resultLabel))~=k
        break;
    end
    objValueVector=[objValueVector objValue];
end
t2=clock;
time=etime(t2,t1);

iterNum=iteratorNum;

categoryNum=length(unique(resultLabel));
end

%֮
    function [dis]=calculateDis(p1,p2)
        dis=0;
        for ii=1:size(p1,2)
            if(p1(1,ii)~=p2(1,ii))
                dis=dis+1;
            end
        end
    end

%ĵ
    function [newCenters]=updataCenters(k,resultLabel,data)
        newCenters=zeros(k,size(data,2));
        for ii=1:k
            tempData=[];
            for jj=1:size(resultLabel,1)
                if(resultLabel(jj,1)==ii)
                    tempData=[tempData;data(jj,:)];
                end
            end
            if size(tempData,1)==1
               tempData=[tempData;tempData];
            end
            newCenters(ii,:)=MyMode(tempData);
        end
    end

    function [functionValue]=calculateObjectFunction(k,resultLabel,data,center)
        functionValue=0;
        for ii=1:k
            centerData=center(ii,:);
            for jj=1:size(data,1)
                if(resultLabel(jj,1)==ii)
                    originalData=data(jj,:);
                    functionValue=functionValue+calculateDis(centerData,originalData);                
                end
            end
        end
    end



end

